//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red

extern string TimeFrame = "Current time frame";
extern int    MA_Period = 13;
extern int    MA_Method = 0;
extern int    Price     = PRICE_CLOSE;
extern color  color_ray = Red;
extern int    width_ray = 1;
extern string UniqueID  = "avg ray";

double ExtMapBuffer[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   SetIndexBuffer(0,ExtMapBuffer);
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
   return(0);
}
int deinit()
{
   ObjectDelete(UniqueID);
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit = MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { ExtMapBuffer[0] = limit+1; return(0); }
            if (timeFrame!=Period())
            {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for(int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,timeFrame,Time[i]);               
                  ExtMapBuffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MA_Period,MA_Method,Price,color_ray,width_ray,UniqueID,0,y);
               }
               return(0);
            }

      for(i=limit; i >= 0; i--) ExtMapBuffer[i] = iMA(NULL,0,MA_Period,0,MA_Method,Price,i);
      ObjectCreate(UniqueID,OBJ_TREND,0,0,0,0,0);
         ObjectSet(UniqueID,OBJPROP_RAY,true);
         ObjectSet(UniqueID,OBJPROP_COLOR,color_ray);
         ObjectSet(UniqueID,OBJPROP_WIDTH,width_ray);
         ObjectSet(UniqueID,OBJPROP_TIME1,Time[1]);
         ObjectSet(UniqueID,OBJPROP_PRICE1,ExtMapBuffer[1]);
         ObjectSet(UniqueID,OBJPROP_TIME2,Time[0]);
         ObjectSet(UniqueID,OBJPROP_PRICE2,ExtMapBuffer[0]);
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}